// Definicija klase jedinstvenih matinih brojeva graana (JMBG).

public class JMBG {
  private static JMBG prvi = null, // Poetak i kraj liste svih objekata.
                      posl = null;
  private JMBG sled = null;        // Sledei objekat u listi.
  private long jmbg;               // Vrednost matinog broja u objektu.
  
  public static boolean ima(long jmbg) { // Da li ve postoji u listi?
    for (JMBG tek=prvi; tek!=null; tek=tek.sled)
      if (jmbg == tek.jmbg) return true;
    return false;
  }
  
  public JMBG(long jmbg) {               // Inicijalizacija novog objekta.
    if (ima(jmbg)) System.exit(1);
    this.jmbg = jmbg;
    if (prvi == null) prvi = this; else posl.sled = this;
    posl = this;
  }
  
  public boolean isti(JMBG jmbg)         // Uporeivanje na jednakost.
    { return this.jmbg == jmbg.jmbg; }
  
  public String toString()               // Tekstualni prikaz mat. broja.
    { return "" + jmbg; }
  
  public static String svi() {           // Tekstualni prikaz svih brojeva.
    String s = "";
    for (JMBG tek=prvi; tek!=null; tek=tek.sled)
      s += tek.jmbg + "\n";
    return s;
  } 
}
