// Definicija klase nizova taaka u ravni (NizTacka).

public class NizTacaka {
  private Tacka1[] tacke;                   // Niz taaka.
  private int brTac = 0;                    // Broj taaka u nizu.
  
  public NizTacaka(int kap)                 // Inicijalizacija objekta.
    { tacke = new Tacka1 [kap]; }
  
  public int brojTacaka() { return brTac; } // Broj taaka u nizu.
  
  public boolean dodaj(Tacka1 t) {          // Dodavanje take nizu.
    if (brTac == tacke.length) return false;
    tacke[brTac++] = t;
    return true;
  }
  
  public Tacka1 dohvati(int ind) {          // Pristup taki u nizu.
    if (ind<0 || ind>=brTac) return null;
    return tacke[ind];
  }
  
  public Tacka1 izvadi(int ind) {           // Vaenje take iz niza.
    if (ind<0 || ind>=brTac) return null;
    Tacka1 t = tacke[ind];
    for (int i=ind; i<brTac-1; tacke[i]=tacke[++i]);
    tacke[--brTac] = null;
    return t;
  }
  
  public String toString() {                // Tekstualni prikaz niza.
    String s = "";
    for (int i=0; i<brTac; s+=tacke[i++]+" ");
    return s;
  }
  
  public static void main(String[] varg) {  // Glavna metoda.
    System.out.print("Broj tacaka? ");
    NizTacaka nt = new NizTacaka(Citaj.Int());
    System.out.print("Niz tacaka? ");
    for (int i=0; i<nt.brojTacaka(); i++) 
      { Tacka1 t = new Tacka1(); t.citaj(); nt.dodaj(t); }
    double z = 0;
    for(int i=0; i<nt.brojTacaka(); z+=nt.dohvati(i++).poteg());
    z /= nt.brojTacaka();
    System.out.println("Srednje odstojanje: " + z);
  }
}
