
// Definicija klase redova objekata (Red1).

public class Red1 {
  private static class Elem {            // Element liste:
    Object obj;                          // - sadrani objekat,
    Elem sled = null;                    // - sledei element,
    Elem(Object obj) { this.obj = obj; } // - inicijalizacija.
  }
  
  private Elem prvi = null, posl = null; // Poetak i kraj reda (liste).
  
  public Red1 stavi(Object obj) {        // Stavljanje na kraj reda.
    Elem novi = new Elem(obj);
    if (prvi == null) prvi = novi;
      else posl.sled = novi;
    posl = novi;
    return this;
  }
  
  public Object uzmi() {                 // Uzimanje s poetka reda.
    if (prvi == null) {
      System.out.print("\n*** Red je prazan ***\n");
      System.exit(1);
    }
    Object obj = prvi.obj;
    prvi = prvi.sled;
    if (prvi == null) posl = null;
    return obj;
  }
  
  public Red1 prazni()                   // Pranjenje reda.
  { prvi = posl = null; return this; }

  public boolean prazan()                // Da li je red prazan?
    { return prvi == null; }
  
  public String toString() {             // Tekstualni prikaz reda.
    StringBuilder sb = new StringBuilder();
    for (Elem tek=prvi; tek!=null; tek=tek.sled)
      sb.append(tek.obj).append('\n');
    return sb.toString();
  }
  
  private Elem tek = null;               // Tekui element obilaska.
  
  public Red1 naPrvi()                   // Poetak obilaska.
    { tek = prvi; return this; }
  
  public Red1 naSledeci() {              // Nastavak obilaska.
    if (tek != null) tek = tek.sled;
    return this;
  }
  
  public boolean imaTekuci()             // Ima li tekueg elementa?
    { return tek != null; }
  
  public Object tekuci()                 // Dohvatanje tekueg objekta.
    { return tek!=null ? tek.obj : null; }
}
