
// Definicija apstraktne klase predmeta (predmeti.Predmet).

package predmeti;

public abstract class Predmet implements Cloneable {

  private static int posId = 0;         // Poslednji identifikator.
  private int id = ++posId;             // Identifikator predmeta.

  public final int id() { return id; }  // Dohvatanje identifikatora.

  public abstract double V();           // Zapremina.

  public abstract double Q();           // Teina.

  public Predmet clone() {              // Kloniranje.
    try {
      Predmet p = (Predmet)super.clone();
      p.id = ++posId;
      return p;
    } catch (CloneNotSupportedException g) { return null; }
  }

  public final String vrsta() {         // Dohvatanje vrste predmeta.
    String s = getClass().getName();
     return  s.substring(s.lastIndexOf('.') + 1);
  }

  public String toString()              // Tekstualni prikaz.
    { return id + " " + vrsta(); }
}
