// Definicija klase obojenih krugova u ravni (ravan.Krug).

package ravan;

public class Krug {
  private static int posId = 0;              // Poslednji identifikator.
  private final int id = ++posId;            // Identifikator kruga.
  private double r;                          // Poluprenik.
  private Tacka C;                           // Poloaj centra.
  private Boja boja;                         // Boja kruga.
  
  public Krug(double r, Tacka C, Boja b)     // Inicijalizacija:
    { this.r = r; this.C = C; boja = b; }    // - zadatim parametrima,
  
  public Krug() {
    r = 1;                                   // - kao jedinini kruga.
    boja = new Boja(0, 0, 0);                //   crne boje
    C = new Tacka();                         //   u koordinatnom poetku
  }
  
  public int id() { return id; }             // Dohvatanje polja.
  public double r() { return r; }
  public Tacka cent() { return C; }
  public Boja boja() { return boja; }
  
  public boolean pripada(Tacka T)            // Da li taka pripada krugu?
    { return T.rast(C) <= r; }
  
  public String toString()                   // Tekstualni prikaz kruga.
    { return String.format("K%d{%.2f,%s,%s}", id, r, C, boja); }
}
