
// Definicija aktivne klase izvetaa (sklad.Izvestac).

package skladiste;

public class Izvestac extends Thread {
  private static int posId = 0;    // Poslednji identifikator.
  private int id = ++posId;        // Identifikator izvetaa.
  private Skladiste<Integer> sklad;// Pridrueno skladite.
  private int perioda;             // Perioda izvestavanja.

  public Izvestac(Skladiste<Integer> skl, int per)   // Inicijalizacija.
    { perioda = per; sklad = skl; }
  
  public Izvestac(Skladiste<Integer> skl) 
    { this(skl, 5000); }
  
  public void run() {                                // Telo niti.
    System.out.println("Izvest " + id + " krenuo");
    try {
      while (!interrupted()) {
        sleep(perioda);
        synchronized (sklad) {
          System.out.print("Izvest " + id + " [Sklad " +
                           sklad.id() + ":");
          for (Integer pro: sklad) System.out.print(" " + pro);
          System.out.println("]");
        }
      }
    } catch (InterruptedException g) {}
    System.out.println("Izvest " + id + " zavrsio");
  }
}