// Definicija klase uporedivih valjaka (uporedivi.Valjak).

package uporedivi;

public class Valjak implements Uporediv {
  private double r, h;                 // Poluprenik osnove i visina.
  
  public Valjak(double rr, double hh)  // Inicijalizacija.
  { r = rr; h = hh; }
  
  public Valjak() { r = h = 1; }
  
  public double r() { return r; }   // Dohvatanje poluprenika.
  
  public double h() { return h; }   // Dohvatanje visine.
  
  public double V() { return r * r * Math.PI * h; } // Raunanje zapremine.

  public boolean ispred(Uporediv u)   // Da li je ispred drugog valjka?
    { return V() > ((Valjak)u).V(); }

  public boolean jednak(Uporediv u) { // Da li je jednak drugom valjku?
    Valjak v = (Valjak)u;
    return r==v.r && h==v.h;
  }

  public String toString()             // Tekstualni prikaz.
    { return String.format("[%.2f,%.2f]", r, h); }
}
