
// Definicija klase zbirke merljivih stvari (zbirka.Zbirka).

package zbirka;

public class Zbirka<E extends Merljiv> {
  Merljiv[] mer;                             // Sadraj zbirke.
  int duz = 0;                               // Broj stvari u zbirci.
  
  public Zbirka(int kap)                     // Inicijalizacija.
    { mer = new Merljiv [kap]; }
  
  public Zbirka<E> dodaj(E e) throws GPuna { // Dodavanje stvari.
    if (duz == mer.length) throw new GPuna();
    mer[duz++] = e;
    return this;
  }
  
  public E uzmi(int ind) throws GIndeks {    // Uzimanje stvari.
    if (ind<0 || ind>=duz) throw new GIndeks();
    Merljiv e = mer[ind]; duz--;
    for (int i=ind; i<duz; mer[i++]=mer[i]);
    mer[duz] = null;
    return (E)e;
  }
  
  private static class Odredi                // Nit za odreivanje
                 extends Thread {            //   veliine jedne stvari:
    Merljiv m;                               // - obraivana stvar,
    double v;                                // - rezultat obrade,
    Odredi(Merljiv mm) { m = mm; }           // - inicijalizacija,
    public void run() { v = m.velicina(); }  // - obrada,
    double rez() { return v; }               // - dohvatanje rezultata.
  }

  public double ukVel() {     // Odreivanje ukupne veliine svih stvari:
    Odredi[] odr = new Odredi [duz];         // - mer niti,
    for (int i=0; i<duz; i++)                // - stvaranje i pokretanje
      (odr[i] = new Odredi(mer[i])).start(); //   niti,
    double uv = 0;
    try {
      for (int i=0; i<duz; i++) {            // - prikupljanje rezultata
         odr[i].join();                      //   (ekanje kraja niti)
         uv += odr[i].rez();                 //   (dohvatanje rezultata).
      }
    } catch (InterruptedException g) {}
    return uv;
  }
}
